---
title: check_field
type: condition
status: stable
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/condition/check_field.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Extracts the value of a field identified via [dot path](/docs/configuration/field_paths)
within messages (currently only JSON format is supported) and then tests the
extracted value against a child condition.


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yaml
# Common config fields, showing default values
check_field:
  path: ""
  condition: {}
```

</TabItem>
<TabItem value="advanced">

```yaml
# All config fields, showing default values
check_field:
  path: ""
  condition: {}
  parts: []
```

</TabItem>
</Tabs>

## Fields

### `path`

A [field path](/docs/configuration/field_paths) to check against the child condition.


Type: `string`  
Default: `""`  

### `condition`

A child condition to test the field contents against.


Type: `object`  
Default: `{}`  

### `parts`

An optional array of message indexes of a batch that the condition should apply to.
If left empty all messages are processed. This field is only applicable when
batching messages [at the input level](/docs/configuration/batching).

Indexes can be negative, and if so the part will be selected from the end
counting backwards starting from -1.


Type: `array`  
Default: `[]`  


