---
title: jmespath
type: condition
status: stable
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/condition/jmespath.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Executes a JMESPath query on JSON payloads, expecting a boolean result. If the
result of the query is true then the condition passes, otherwise it does not.


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yaml
# Common config fields, showing default values
jmespath:
  query: ""
```

</TabItem>
<TabItem value="advanced">

```yaml
# All config fields, showing default values
jmespath:
  query: ""
  part: 0
```

</TabItem>
</Tabs>

Please refer to the [JMESPath website](http://jmespath.org/) for information and
tutorials regarding the syntax of expressions.

## Fields

### `query`

A [JMESPath](http://jmespath.org/) query.


Type: `string`  
Default: `""`  

```yaml
# Examples

query: foo == 'bar'

query: length(doc.urls) > `0`
```

### `part`

The index of a message within a batch to test the condition against. This
field is only applicable when batching messages
[at the input level](/docs/configuration/batching).

Indexes can be negative, and if so the part will be selected from the end
counting backwards starting from -1.


Type: `number`  
Default: `0`  

## Examples

With the following config:

``` yaml
jmespath:
  query: a == 'foo'
```

If the initial jmespaths of part 0 were:

``` json
{
	"a": "foo"
}
```

Then the condition would pass.

JMESPath is traditionally used for mutating JSON, in order to do this please
instead use the [`jmespath`](/docs/components/processors/jmespath)
processor.

